#include <allegro.h>
#include "colision.h"

#ifndef __LOCOMOTORA_H__
#define __LOCOMOTORA_H__

BITMAP *buffer;

class locomotora
{
      public:
       fix x;
       fix y;
       
       int x0;
       int y0;
       int x1;
       int y1;

       fix velocidad_x;
       fix velocidad_y;
       fix velocidad;

       fix direccion;
       int frame_actual;
       DATAFILE *dloco;
       
       bool controlar;
       
       void iniciar();
       void procesar();
       void dibujar(int,int);
};


void locomotora::iniciar()
{
     x=570;
     y=480;
     
     velocidad_x=0;
     velocidad_y=0;
     velocidad=0;
     
     controlar=true;
     
     direccion=192;
     dloco = load_datafile("loco.dat");
}


void locomotora::procesar()
{
     if(controlar)
     {
         if(key[KEY_LEFT]) direccion-=2;
         if(key[KEY_RIGHT]) direccion+=2;
     }
     if(direccion>255) direccion=0;
     if(direccion<0) direccion=255;

     frame_actual=(int)direccion/8;
//     direccion=frame_actual*8;
     
     if(key[KEY_UP])
     {
         if(velocidad<8)
         {
             if(controlar)
             velocidad+=0.5;
         }
     }
     else if(key[KEY_DOWN])
     {
         if(velocidad>-3)
         {
             if(controlar)
             velocidad-=0.5;
         }
     }
     
     else
     {
         if(velocidad<0)
         {
             velocidad+=0.5;
         }     
         if(velocidad>0)
         {
             velocidad-=0.5;
         }
     }
     
     velocidad_x=-velocidad*sin(direccion);
     velocidad_y=velocidad*cos(direccion);
     x+=velocidad_x;
     y+=velocidad_y;
     
     
     if(frame_actual==0)
     {
         x0=x+25;
         y0=y+7;
         x1=x+54;
         y1=y+68;
     }
     else if(frame_actual==1)
     {
         x0=x+25; 
         y0=y+6; 
         x1=x+54; 
         y1=y+68;
     }
     else if(frame_actual==2)
     {
         x0=x+25;
         y0=y+5;
         x1=x+54;
         y1=y+67;
     }
     else if(frame_actual==3)
     {
         x0=x+25; 
         y0=y+5; 
         x1=x+54; 
         y1=y+66;
     }
     else if(frame_actual==4)
     {
         x0=x+11; 
         y0=y+6; 
         x1=x+70; 
         y1=y+65;
     }
     else if(frame_actual==5)
     {
         x0=x+10; 
         y0=y+14; 
         x1=x+72; 
         y1=y+54;
     }
     else if(frame_actual==6)
     {
         x0=x+9; 
         y0=y+14; 
         x1=x+75; 
         y1=y+54;
     }
     else if(frame_actual==7)
     {
         x0=x+9; 
         y0=y+14; 
         x1=x+74; 
         y1=y+54;
     }
     else if(frame_actual==8)
     {
         x0=x+9; 
         y0=y+14; 
         x1=x+73; 
         y1=y+55;
     }
     else if(frame_actual==9)
     {
         x0=x+9; 
         y0=y+15; 
         x1=x+74; 
         y1=y+56;
     }
         
     else if(frame_actual==10)
     {
         x0=x+9; 
         y0=y+13; 
         x1=x+74; 
         y1=y+59;
     }
     else if(frame_actual==11)
     {
         x0=x+10; 
         y0=y+11; 
         x1=x+72; 
         y1=y+63;
     }
     else if(frame_actual==12)
     {
         x0=x+11; 
         y0=y+9; 
         x1=x+70; 
         y1=y+66;
     }
     else if(frame_actual==13)
     {
         x0=x+13; 
         y0=y+8; 
         x1=x+67; 
         y1=y+70;
     }
     else if(frame_actual==14)
     {
         x0=x+17; 
         y0=y+6; 
         x1=x+62; 
         y1=y+70;
     }
     else if(frame_actual==15)
     {
         x0=x+21; 
         y0=y+6; 
         x1=x+57; 
         y1=y+71;
     }
     else if(frame_actual==16)
     {
         x0=x+25; 
         y0=y+5; 
         x1=x+53; 
         y1=y+71;
     }
     else if(frame_actual==17)
     {
         x0=x+22; 
         y0=y+6; 
         x1=x+59; 
         y1=y+71;
     }
     else if(frame_actual==18)
     {
         x0=x+17; 
         y0=y+6; 
         x1=x+62; 
         y1=y+70;
     }
     else if(frame_actual==19)
     {
         x0=x+12; 
         y0=y+8; 
         x1=x+65; 
         y1=y+69;
     }
         
     else if(frame_actual==20)
     {
         x0=x+8; 
         y0=y+9; 
         x1=x+67; 
         y1=y+67;
     }
     else if(frame_actual==21)
     {
         x0=x+6; 
         y0=y+11; 
         x1=x+69; 
         y1=y+63;
     }
     else if(frame_actual==22)
     {
         x0=x+5; 
         y0=y+13; 
         x1=x+69; 
         y1=y+59;
     }
     else if(frame_actual==23)
     {
         x0=x+5; 
         y0=y+15; 
         x1=x+70; 
         y1=y+56;
     }
     else if(frame_actual==24)
     {
         x0=x+5; 
         y0=y+14; 
         x1=x+69; 
         y1=y+54;
     }
     else if(frame_actual==25)
     {
         x0=x+5; 
         y0=y+11; 
         x1=x+70; 
         y1=y+58;
     }
     else if(frame_actual==26)
     {
         x0=x+5;
         y0=y+9; 
         x1=x+69; 
         y1=y+61;
     }
     else if(frame_actual==27)
     {
         x0=x+6; 
         y0=y+7; 
         x1=x+68; 
         y1=y+63;
     }
     else if(frame_actual==28)
     {
         x0=x+8; 
         y0=y+6; 
         x1=x+67; 
         y1=y+65;
     }
     else if(frame_actual==29)
     {
         x0=x+12; 
         y0=y+5; 
         x1=x+65; 
         y1=y+66;
     }

     else if(frame_actual==30)
     {
         x0=x+17; 
         y0=y+5; 
         x1=x+62; 
         y1=y+67;
     }
     else if(frame_actual==31)
     {
         x0=x+21; 
         y0=y+6; 
         x1=x+58; 
         y1=y+68;
     }

}

void locomotora::dibujar(int _x,int _y)
{
     draw_sprite(buffer,(BITMAP *)dloco[frame_actual].dat,_x,_y);
}
     
     
#endif
