#include <allegro.h>
#include "camara.h"
#include "misiones.h"
#include "estado.h"
#include "menu.h"
#include "ascii.h"
#include"creditos.h"
#include"contador.h"

void init();
void deinit();

locomotora player1;
mapa       mapa1;
camara     camara1;
flecha     flecha1;
objetivo   aaa;

bool paused=false;

DATAFILE *casas;
DATAFILE *midis;

int main() {
	init();
    
    if(!menu())
    {
        deinit();
        return 0;
    }
    
    player1.iniciar();
    mapa1.iniciar();
    
    iniciar_misiones();
    
    flecha1.mostrar=true;
    estado_del_juego=1;
    evento=true;
    
  contador=0;
  contador2=0;
  play_midi((MIDI*)midis[0].dat,1);
  set_tiempo(15,0);
    
    while (!key[KEY_ESC] && !__exit) 
    {
        while(contador>0)
        {
            player1.procesar();

            camara1.set_objetivo(player1.x-320,player1.y-205);
            camara1.procesar();

    		if(mapa1.check_colision(player1.x0,player1.y0,player1.x1,player1.y1))
    		{
                player1.velocidad=-player1.velocidad;
            }
            
            aaa:
            if(key[KEY_ENTER]) 
            {
                reloj_encendido=true;
                paused=!paused;
                clear(screen);
                while(key[KEY_ENTER]) {}
            }
            if(paused)
            {
                clear(buffer);
                reloj_encendido=false;

                textprintf_centre_ex(buffer, font, 320, 240, makecol(255,255,255), -1, "Paused");
                textprintf_centre_ex(buffer, font, 320, 280, makecol(255,255,255), -1, "Help:");
                textprintf_centre_ex(buffer, font, 320, 320, makecol(255,255,255), -1, "Move with arrow keys");
                textprintf_centre_ex(buffer, font, 320, 360, makecol(255,255,255), -1, "Pause with enter");
                draw_sprite(screen,buffer,0,0);
      
                contador=0;
                contador2=0;
                goto aaa;
            }
            
            flecha1.x=player1.x;
            flecha1.y=player1.y;
            
            flecha1.objetivo_x=mision_1[mision_actual].objetivo_x;
            flecha1.objetivo_y=mision_1[mision_actual].objetivo_y;

            flecha1.update();
            mision_1[mision_actual].update();
            
            if(check_tiempo())
            {
                player1.x=mision_1[mision_actual-1].objetivo_x;
                player1.y=mision_1[mision_actual-1].objetivo_y;
                set_tiempo(15,0);
                reloj_encendido=true;
            }
            if(!dialogo_activo)
            {
                reloj_encendido=true;
            }
            else
            {
                reloj_encendido=false;
            }

            que_hacer();
           
            contador--;
        }
        
        if(!frame_dibujado)
        {
            if(!asc)
            {
            clear_to_color(buffer,makecol(108,195,104));
    		
            mision_1[mision_actual].dibujar();
    		player1.dibujar(player1.x-camara1.x,player1.y-camara1.y);
        
            masked_blit(mapa1.bmp, buffer, camara1.x, camara1.y, 0, 0, 640, 410);
         
            if(key[KEY_F1])
            {
                //save_bitmap("aaa.bmp",buffer, NULL);
                cambiar_dialogo(1);
            }
   	        show_dialogo();

   //         vsync();
            flecha1.dibujar();
            if(player1.controlar)
            textprintf_ex(buffer, font, 600, 0, makecol(255,255,255), -1, "%d:%d", reloj_segundos,reloj_msegundos);
    		draw_sprite(screen,buffer,0,0);
    		if(dialogo_activo)
            draw_sprite(screen,dialog,0,410);
            }
            else if(asc)
            {
                 show_ascii();
            }
        }
	}


	deinit();
	return 0;
}
END_OF_MAIN()

void init() 
{
	allegro_init();
	set_color_depth(16);
	if(set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0)!=0)
	{
		allegro_message(allegro_error);
		exit(-1);
	}

	install_timer();
	install_keyboard();
	install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);
	set_volume(128, 128);
	
	buffer=create_bitmap(640,410);
	dialog=create_bitmap(640,70);
	tmp=create_bitmap(640,480);
	
	casas = load_datafile("casas.dat");
	caras = load_datafile("caras.dat");
	gfx   = load_datafile("gfx.dat");
	midis = load_datafile("midis.dat");
	
    LOCK_VARIABLE(contador);
    LOCK_VARIABLE(contador2);
	LOCK_FUNCTION(contar);
	LOCK_FUNCTION(contar2);
	install_int_ex(contar, BPS_TO_TIMER(40));
	install_int_ex(contar2, BPS_TO_TIMER(20));
	install_int_ex(reloj, BPS_TO_TIMER(100));
	
	cambiar_dialogo(0);
}

void deinit() 
{
	clear_keybuf();
	unload_datafile(casas);
	unload_datafile(caras);
	unload_datafile(gfx);
	unload_datafile(midis);
	destroy_bitmap(buffer);
	destroy_bitmap(dialog);
	destroy_bitmap(tmp);
}
